import os
import hashlib
from settings import LAUNCHPADLOCKS_DIR


class MergeProposalReview():
    _mp = None

    def __init__(self, mp):
        self._mp = mp

    @property
    def mp(self):
        """Merge proposal."""

        return self._mp

    def _get_hash(self):
        return hashlib.sha224(self.mp.web_link).hexdigest()
    
    def get_lockfile(self):
        return LAUNCHPADLOCKS_DIR + '/' + self._get_hash()

    def lock(self):
        if not os.path.exists(LAUNCHPADLOCKS_DIR):
            os.makedirs(LAUNCHPADLOCKS_DIR)
        lockfile = open(self.get_lockfile(), 'w')
        lockfile.write(self.mp.web_link)
        lockfile.close()

    def unlock(self):
        try:
            os.remove(self.get_lockfile())
            return True
        except OSError as error:
            if error.errno == 2:
                print "DEBUG: mp lock doesn't exists. Ignoring this unlock."
            return False

    def is_locked(self):
        return os.path.exists(self.get_lockfile())
